#ifdef GL_ES
precision mediump float;
#endif
uniform mat4 modelview;
uniform mat4 projection;
uniform vec4 LightPosition;

attribute vec3 position;
attribute vec2 texcoord;

varying vec4 vertex_position;
varying vec3 eye_direction;
varying vec4 light_position;
varying vec2 TextureCoord;

vec3 unitvec(vec4 v1, vec4 v2)
{
    if (v1.w == 0.0 && v2.w == 0.0)
        return vec3(v2 - v1);
    if (v1.w == 0.0)
        return vec3(-v1);
    if (v2.w == 0.0)
        return vec3(v2);
    return v2.xyz/v2.w - v1.xyz/v1.w;
}

void main()
{
    vec4 curVertex = vec4(position.x, position.y, position.z, 1.0);
    gl_Position = projection * modelview * curVertex;
    TextureCoord = texcoord;
    light_position = modelview * LightPosition;
    vertex_position = modelview * curVertex;
    eye_direction = normalize(unitvec(vertex_position, vec4(0.0, 0.0, 0.0, 1.0)));
}
