/*
 * Copyright © 2011 Linaro Limited
 *
 * This file is part of glcompbench.
 *
 * glcompbench is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * glcompbench is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with glcompbench.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *  Alexandros Frantzis <alexandros.frantzis@linaro.org>
 *  Jesse Barker <jesse.barker@linaro.org>
 */

#include "composite-window-gl.h"
#include "log.h"

CompositeWindowGL::~CompositeWindowGL()
{
    if (tex_)
        glDeleteTextures(1, &tex_);
}

bool
CompositeWindowGL::update_texture()
{
    bool ret = false;

    if (!tex_ && attr_.map_state != 0) {
        glGenTextures(1, &tex_);

        glBindTexture(GL_TEXTURE_2D, tex_);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

        Log::debug("    => texture <= 0x%x\n", (unsigned) tex_);
        ret = true;
    }
    else if (tex_ && attr_.map_state == 0) {
        Log::debug("    => Deleting texture 0x%x\n", (unsigned) tex_);
        glDeleteTextures(1, &tex_);
        tex_ = 0;
    }

    return ret;
}

